/*
 * Copyright 2002-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * PROJECT:     CTesK
 * FILE:        engine_tsi.h
 * AUTHOR:      Alexey V. Khoroshilov
 * CREATION:    18 April 2005
 * DESCRIPTION: Common properties of test engines.
 * SCOPE:       It is an internal header.
 */

#ifndef TS_ENGINE_INTERNAL_INTERFACE_HPP
#define TS_ENGINE_INTERNAL_INTERFACE_HPP

#include <ts/engine.h>
#include <ts/generated.h>
#include <utils/assertion.h>

#include <ts/scenario.hpp>

struct CppArcSymbolExecutor
{
  ModelStateManager   model_state;
  cpptesk::ts::scenario_method_base** actions;
} ;

#endif
