/*
 * Generated by veritool: Copyright (c) 2009-2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

#include <vpi_systf.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include <ts/scenario.h>
#include <utils/testreg.h>
#include <sync.h>

/* Create new source file with code like this:

   #include <utils/testreg.h>

   extern TestScenario example1_scen;
   extern TestScenario example2_scen;
   ClassOfScenario example3_scen;

   TEST_REGISTRY_BEGIN
   REGISTER_CTESK_TEST(example1_scen, engine::fsm, "")
   REGISTER_CTESK_TEST(example2_scen, engine::rnd, "")
   REGISTER_TEST(example3_scen, engine::rnd, NULL)
   TEST_REGISTRY_END
*/

char scen_argv[SCEN_ARGV_LENGTH];

////////////////////////////////////////////////////////////////////////////////
// VPI Tasks and Functions
////////////////////////////////////////////////////////////////////////////////
static int calltf_set_scenario(char *user_data)
{
    s_vpi_value value;
    vpiHandle obj = vpi_handle(vpiSysTfCall, NULL);

    if(user_data) {}

    assert(obj != NULL);

    if(obj != NULL)
    {
        bool netscen = false;
        vpiHandle itr = vpi_iterate(vpiArgument, obj);

        vpiHandle arg = vpi_scan(itr);
        value.format = vpiStringVal;
        vpi_get_value(arg, &value);
        if(*value.value.str == 1)
            netscen = true;

        arg = vpi_scan(itr);
        vpi_get_value(arg, &value);
        strcpy(scen_argv, value.value.str);

        arg = vpi_scan(itr);
        vpi_get_value(arg, &value);

        vpi_free_object(obj);
        vpi_free_object(itr);
        vpi_free_object(arg);

#ifdef __cplusplus
        return startscen_cpp_TestRegistry(netscen, value.value.str, scen_argv);
#else
        return startscen_TestRegistry(netscen, value.value.str, scen_argv);
#endif
    }

    return 0;
}

static int calltf_apply_action(char *user_data)
{
    if(user_data) {}
    return 0;
}

static int calltf_check_action(char *user_data)
{
    if(user_data) {}
    apply_check();
    return 0;
}

////////////////////////////////////////////////////////////////////////////////
// Registration of VPI Tasks and Functions
////////////////////////////////////////////////////////////////////////////////
static void register_calltf_set_scenario(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_SET_SCENARIO;
    tf_data.calltf      = calltf_set_scenario;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

static void register_calltf_apply_action(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_APPLY_ACTION;
    tf_data.calltf      = calltf_apply_action;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

static void register_calltf_check_action(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_CHECK_ACTION;
    tf_data.calltf      = calltf_check_action;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

void (*vlog_startup_routines[])(void) =
{
    register_calltf_set_scenario,
    register_calltf_apply_action,
    register_calltf_check_action,
    NULL
};

