/** @file counter_msg.h
 * This file contains message classes description.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/message.hpp>

namespace cpptesk {
namespace examples {
namespace counter {

MESSAGE(InputData)
{
public:
    InputData();
    InputData(int id, int timemark);
    virtual ~InputData();

    SUPPORT_CLONE(InputData);
    DECLARE_FIELD(id, 32);
    DECLARE_FIELD(timemark, 32);
};

MESSAGE(OutputData)
{
public:
    OutputData();
    OutputData(uint8_t data);
    OutputData(int id, int timemark);
    virtual ~OutputData();

    SUPPORT_CLONE(OutputData);
    DECLARE_FIELD(data, 8);
    DECLARE_FIELD(id, 32);
    DECLARE_FIELD(timemark, 32);
};

}}}
