/*Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "hw/event.hpp"
#include "errmodel.hpp"
#include "rset.hpp"

#include <stdio.h>

namespace cpptesk {
namespace hw {
namespace diagnostics {

class Diagnostics 
{
  public: 
  ErrorModel _errorModel;
  ReactionSet _reactionSet;
  
  Diagnostics()
  {  //Empty
  }

  virtual ~Diagnostics()
  {  //Empty
  }

  void registerReaction(Reaction &_reaction)
  {
    _reactionSet.initialization(_reaction);
  }

  void cycle()
  {
    // Add to ErrorModel rules
    _errorModel.initialization();
    // Get reactions for diagnostic
    //_reactionSet.initialization(_reaction);
  
    // Collapse!
    if(_reactionSet._reactionVector.size() > 0)
    {
        ReactionUnit r1 = _reactionSet._reactionVector[0];
        std::cout << "cycle:" << std::endl;
       _errorModel.transform(r1._reaction, r1._reaction /*_reactionSet._reactionVector[0], _reactionSet._reactionVector[0]*/);
    }
  }    
};

}}}
