/*Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "rule.hpp"
#include "correctrule.hpp"

#include "hw/event.hpp"

namespace cpptesk {
namespace hw {
namespace diagnostics {

class ErrorModel: 
      public Rule
{
  public: 
    ErrorModel() {};
    virtual ~ErrorModel() {};

  unsigned int priority;  
  std::vector<Rule> ruleSet;
  
  /*ErrorModel::ErrorModel()
  {  //Empty
  }

  ErrorModel::~ErrorModel()
  {  //Empty
  }*/

  void addRule(Rule &_rule)
  // Add rule to the ruleSet 
  {
    ruleSet.push_back(_rule);
  }

  void initialization()
  {
    CorrectReactionEliminationRule rule1;
    addRule(rule1 /*CorrectReactionEliminationRule()*/);
  }

  TransformUnit transform(::cpptesk::hw::Reaction _reaction_1, ::cpptesk::hw::Reaction _reaction_2)
  // Collapse the reactions
  {
    Rule& _rule = ruleSet[0];
    TransformUnit _transform_out = _rule.transform(_reaction_1, _reaction_2);
    std::cout << _reaction_1 << " // " << _reaction_2 << std::endl;
    return _transform_out; 
  }

  int match(::cpptesk::hw::Reaction _reaction_1, ::cpptesk::hw::Reaction _reaction_2)
  // Compare the reactions
  {
    Rule& _rule = ruleSet[0];
    int _match_value = _rule.match(_reaction_1, _reaction_2);
    return _match_value;
  }

  void weight()
  // Get the weight of operation
  {
  }

  void distance()
  //  
  {
  }
 
};

}}}
