/*Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "hw/event.hpp"

namespace cpptesk {
namespace hw {
namespace diagnostics {

class ReactionUnit //ReactionUnit
{
public:
  ReactionUnit(::cpptesk::hw::Reaction &_r) : _reaction(_r)
  {
    _childReaction1 = 0;
    _parentReaction1 = 0;
    _childReaction2 = 0;
    _parentReaction2 = 0;
    _useInCollapse = 0;    
  }
  virtual ~ReactionUnit() {}

  ::cpptesk::hw::Reaction _reaction;
  int _useInCollapse;
  int _childReaction1;
  int _childReaction2;
  int _parentReaction1, _parentReaction2;
};

}}}
