/** @file fifo_coverage.cpp
 * This file contains the coverage class implementation.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <fifo_coverage.h>
#include <fifo_model.h>

namespace cpptesk {
namespace examples {
namespace fifo {

FIFOCoverage::FIFO_FULLNESS FIFOCoverage::cov_FF(void) const
{
    switch(fifo.fifo_fullness()) {
        case 0:  return FIFOCoverage::FIFO_FULLNESS::I0;
        case 1:  return FIFOCoverage::FIFO_FULLNESS::I1;
        case 2:  return FIFOCoverage::FIFO_FULLNESS::I2;
        case 3:  return FIFOCoverage::FIFO_FULLNESS::I3;
        case 4:  return FIFOCoverage::FIFO_FULLNESS::I4;
        case 5:  return FIFOCoverage::FIFO_FULLNESS::I5;
        case 6:  return FIFOCoverage::FIFO_FULLNESS::I6;
        case 7:  return FIFOCoverage::FIFO_FULLNESS::I7;
        case 8:  return FIFOCoverage::FIFO_FULLNESS::I8;
        case 9:  return FIFOCoverage::FIFO_FULLNESS::I9;
        case 10: return FIFOCoverage::FIFO_FULLNESS::I10;
        case 11: return FIFOCoverage::FIFO_FULLNESS::I11;
        case 12: return FIFOCoverage::FIFO_FULLNESS::I12;
        case 13: return FIFOCoverage::FIFO_FULLNESS::I13;
        case 14: return FIFOCoverage::FIFO_FULLNESS::I14;
        case 15: return FIFOCoverage::FIFO_FULLNESS::I15;
        case 16: return FIFOCoverage::FIFO_FULLNESS::I16;
        default: assert(false);
    }
}

void FIFOCoverage::out_cov_FF(void) {
      coverageTracker << FIFOCoverage::cov_FF();
}

}}}
