#!/bin/sh
echo COPY CONFIG_DIR=$CONFIG_DIR HOST=$HOST PORT=$PORT TESTRUN=$TESTRUN PREVTESTRUN=$PREVTESTRUN

CLUSTER_DIR=$CONFIG_DIR/clusters/$CLUSTER
# load common functions & variables
. $CLUSTER_DIR/cluster.conf

FUNCTIONS_DIR=`dirname $0`
. $FUNCTIONS_DIR/functions.sh

TESTRUN_DIR=$TESTRUNS_DIR/$TESTRUN
TEST_DIR=$TESTRUN_DIR/$PORT

mkdir -p $TEST_DIR

if [ -n $PREVTESTRUN -a $PREVTESTRUN != "--" ]
then
    CHCKPNT=$TESTRUNS_DIR/$PREVTESTRUN/$CHECK_POINT
    echo -n "Copying a check point..."
    if [ -f $CHCKPNT ]
    then
        cp -f $CHCKPNT $TEST_DIR
        check_exit
    else
        check_warning
    fi
fi

echo -n "Copying test files...   "
cp -rf $CONFIG_DIR/tests/$TESTNAME/* $TEST_DIR
check_exit

echo COPY END
