#!/bin/sh

# if $PORT is not defined, run for all instances
# if $TESTRUN is not defined, kills all testruns
echo KILL CLUSTER=$CLUSTER TESTRUNS_DIR=$TESTRUNS_DIR TESTRUN=$TESTRUN PORT=$PORT

CUR_DIR=`dirname $0`
# set the cluster dir
if [ -f $CUR_DIR/cluster.conf ]
then
    # kill.sh run from terminal
    CLUSTER_DIR=`pwd`/$CUR_DIR
else 
    # kill.sh rum from mcc
    CLUSTER_DIR=`pwd`/conf/clusters/mcst
fi

# load common functions & variables
. $CLUSTER_DIR/../../functions.sh
. $CLUSTER_DIR/cluster.conf

FIND_TESTRUN="--testrun="$TESTRUN
FIND_PORT="-p $PORT"
PIDS=`ps ax | grep -e "$FIND_TESTRUN" | grep -e "$FIND_PORT" | grep -v grep | awk '{print $1}'`

if [ -n "$PIDS" ]
then
    echo -n "Killing all processes with $FIND_TESTRUN and $FIND_PORT..."
    kill -9 $PIDS 2>/dev/null
    check
else
    echo "No processes found with $FIND_TESTRUN and $FIND_PORT"
fi

echo KILL END
